<template>
  <div class="common-global">
    <header-m-main
      :theme-properties="themeProperties"
      :auth="authentication"
      :actived-tab="included"
    />
    <theme-desktop-global-components-header-nav v-if="included" />
    <div
      v-if="isShowAnnouncement && !isIndependentModule"
      class="announcement py-2 bg-background1 h-[32px] pl-4 overflow-hidden"
    >
      <div class="container flex items-center h-full mx-auto">
        <utils-announcement :announcement="announcement.Text" />
      </div>
    </div>
    <BannerMobileRender
      v-if="isAllowBannerRoute && !isIndependentModule"
      :actived-tab="activedTab"
      :banner-keys="bannerKeys"
    />
    <slot :auth="authentication" :theme-properties="themeProperties" class="pb-14"/>
    <lazy-footer v-if="exceptIllegelRoutes" template="global" layout="mobile" />
    <new-black-theme-agent-cooperation-dialog />
    <new-black-theme-register-dialog v-if="!register.IsHidden && !isRegister" />
    <new-black-theme-login-dialog />
  </div>
</template>

<script setup lang="ts">
import _ from "lodash";
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
import { store } from "~~/store";

const illegelRoutes: Array<string> = [
  "bethistory",
  "deposit",
  "wallet",
  "account",
  "aboutus",
  "transaction-history",
  "withdrawal",
  "referral",
  "helpcenter",
];
const route = useRoute();
const tabSelected = computed(() =>
  _.replace(_.replace(route.path.split("/")[1], "-", ""), "/", "").toLowerCase()
);
const exceptIllegelRoutes = computed(
  () => !_.includes(illegelRoutes, tabSelected.value)
);
const authentication = computed(() => store.state.auth);
const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);
const register = computed(() =>
  themePropertyHelper.getSingleThemeProperty(themeProperties.value, "register")
);
const isRegister = computed(() => useRoute().name === "register");
const gameLobby: Array<string> = [
  "home",
  "sports",
  "virtualsports",
  "livecasino",
  "games",
  "keno",
  "cockfight",
  "lottery",
  "poker",
  "promotion",
];
const tabSelectedLobby = computed(() =>
  _.replace(_.replace(route.path.split("/")[1], "-", ""), "/", "")
);
const activedTab = computed(() =>
  tabSelectedLobby.value !== "" ? tabSelectedLobby.value : "Home"
);
const included = computed(() =>
  _.includes(gameLobby, _.toLower(activedTab.value))
);
const toggleBodyClass = () => {
  if (String(route.path).includes('/transaction-history')) {
    document.body.classList.add('transaction-page');
  } else {
    document.body.classList.remove('transaction-page');
  }
};

const allowBannerRoute = [
  "home",
  "virtualsports",
  "livecasino",
  "games",
  "keno",
  "cockfight",
  "lottery",
  "poker",
];

const isAllowBannerRoute = computed(() =>
  _.includes(allowBannerRoute, _.toLower(activedTab.value))
);

watch(()=> route.path, () => {
  toggleBodyClass();
},{ immediate: true });
onMounted(() => {
  useSetV2Layout();
});
const bannerKeys: Record<string, string> = {
  home: "lobby_banner_",
  sports: "sport_banner_",
  virtualsports: "virtual_sport_banner_",
  livecasino: "live_casino_banner_",
  games: "game_banner_",
  poker: "poker_banner_",
  lottery: "lottery_banner_",
  cockfight: "cockfight_banner_",
  promotion: "promotion_banner_",
};
const { isIndependentModule } = useIndependentModule();
const announcement = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "announcement"
    )
);
const isShowAnnouncement = computed(() => {
  if (!announcement.value) return false;
  return (
    isAllowBannerRoute.value &&
    !announcement.value.IsHidden &&
    !isIndependentModule.value
  );
});
</script>

<style lang="scss">
[layout="global"] .mGameEntry .stickySearchGameFilter.fixedSearchGameFilter {
  top: 92px !important;
}
body {
  overflow: hidden;
}
.transaction-page {
  overflow: auto;
}
@import "@/assets/styles/mobile/common.scss";
.common-global {
  width: 100%;
  height: 100%;
  overflow: hidden;
  .text-tertiary {
    color: var(--tertiary);
  }
  .mb-\[12vw\] {
    padding-bottom: 2.5rem;
    overflow: auto;
    background: var(--background2);
    margin-bottom: 0;
  }
  .tabs-statement.demo-tabs {
    background: var(--background1);
    & .el-tabs__nav-wrap {
      padding: 0;
      .el-tabs__nav-scroll {
        overflow: auto;
      }
      & .el-tabs__nav {
        width: 100%;
      }
      & .el-tabs__active-bar {
        width: 25%;
        background-color: var(--selected);
      }
      & .el-tabs__item.is-active {
        color: var(--selected);
      }
      & .el-tabs__item {
        width: 25%;
        text-align: center;
        padding-left: 14px !important;
        padding-right: 14px !important;
      }
    }
  }
  .demo-tabs {
    background: var(--background1);
    & .el-tabs__nav-wrap {
      padding: 0;

      & .el-tabs__nav {
        width: 100%;
      }
      & .el-tabs__active-bar {
        width: 50%;
        background-color: var(--secondary);
      }
      & .el-tabs__item.is-active {
        color: var(--secondary);
      }
      & .el-tabs__item {
        width: 50%;
        text-align: center;
        padding-left: 14px !important;
        padding-right: 14px !important;
      }
    }
  }
  .flex.flex-col.p-5.space-y-2.bg-background2 {
    height: calc(100vh - 52px);
    height: calc(100svh - 52px);
    background: var(--background1);
    .balance-box {
      border: 1px solid var(--border);
      h2 {
        color: var(--secondary);
        line-height: 33px;
        font-weight: 700;
        font-size: 28px;
      }
    }
    button.wallet-deposit-btn.el-button {
      width: 100%;
      height: 40px;
      background-color: var(--primary);
      border: none;
      margin-left: 0;
    }
    .el-button span {
      @apply text-xs font-bold leading-[14px];
      color: var(--textBtn);
    }
    button.wallet-withdrawal-btn.el-button {
      width: 65%;
      height: 40px;
      background-color: var(--primary);
      border: none;
      margin-left: 8px;
      span {
        overflow: hidden;
        text-overflow: ellipsis;
        display: block;
      }
    }
  }
  .flex.flex-col.p-5.space-y-2.bg-background3 {
    height: calc(100vh - 52px);
    height: calc(100svh - 52px);
    background: var(--background3);
    .balance-box {
      border: 1px solid var(--border);
      background: var(--background1);
      h2 {
        color: var(--secondary);
        line-height: 33px;
        font-weight: 700;
        font-size: 28px;
      }
    }
    button.wallet-deposit-btn.el-button {
      width: 35%;
      height: 40px;
      background-color: var(--primary);
      border: none;
      margin-left: 0;
    }
    .el-button span {
      @apply text-xs font-bold leading-[14px];
      color: var(--textBtn);
    }
    button.wallet-withdrawal-btn.el-button {
      width: 65%;
      height: 40px;
      background-color: var(--primary);
      border: none;
      margin-left: 8px;
      span {
        overflow: hidden;
        text-overflow: ellipsis;
        display: block;
      }
    }
  }
  .fixed-header {
    // position: unset;
    .el-tabs.el-tabs--top {
      & .el-tabs__nav-wrap {
        padding: 0;

        & .el-tabs__nav {
          width: 100%;
        }
        & .el-tabs__active-bar {
          width: 33.3333%;
          background-color: var(--secondary);
        }
        & .el-tabs__item.is-active {
          color: var(--secondary);
        }
        & .el-tabs__item {
          width: 33.3333%;
          text-align: center;
          padding-left: 14px !important;
          padding-right: 14px !important;
        }
      }
    }
  }
  .overflow-auto.mt-\[48px\] {
    height: calc(100vh - 90px);
    overflow: auto;
  }

  .payment-bank-menu {
    color: var(--text);
    border-bottom: 2px solid transparent;
  }
  .payment-bank-menu.selected-tab {
    color: var(--secondary);
    font-weight: 500;
    border-color: var(--secondary);
  }
  .divider-y.mb-\[12vw\] {
    padding-bottom: 6.8rem;
    overflow: auto;
    background: var(--background2);
    margin-bottom: 0;
    .px-5.py-6.space-y-4 {
      background: var(--background2);
    }
    & h5 {
      color: var(--hint);
    }
    .el-radio-button {
      --el-radio-button-checked-border-color: var(--primary);
      --el-radio-button-checked-bg-color: rgb(0, 0, 0, 0);
      --el-radio-button-checked-text-color: var(--text);
      margin-right: 0;
      height: 100%;
      min-height: 32px;

      .check-img {
        height: 18px !important;
      }
      &.is-active {
        & .el-radio-button__inner {
          @apply w-full text-center p-0 h-full min-h-[32px] pl-0 inline-flex items-center justify-center leading-[14px] text-xs font-bold;
          box-shadow: none !important;
          border: var(--secondary) solid 2px;
          white-space: break-spaces;
          color: var(--secondary);
        }
      }
      & .el-radio-button__inner {
        @apply w-full text-center p-0 h-full min-h-[32px] pl-0 inline-flex items-center justify-center leading-[14px] text-xs font-bold;
        box-shadow: none !important;
        border: var(--border) solid 2px;
        white-space: break-spaces;
        color: var(--text);
        & img {
          height: 100%;
        }
      }
      & .el-radio-button__inner::before {
        background: var(--secondary) !important;
      }
      .el-radio-button__original-radio:checked + .el-radio-button__inner,
      &:first-child
        .el-radio-button__original-radio:checked
        + .el-radio-button__inner {
        border-color: var(--secondary);
      }
    }
    .slip-card {
      width: 100%;
      height: 132px;

      /* KR Theme/Background1 */

      background: var(--background1);
      /* KR Theme/Border */

      border: 1px dashed #4d5080;
      border-radius: 8px;
    }
    .slip-card button.el-button {
      width: 152px;
      height: 40px;
    }
  }
  .el-button.el-button--primary.is-round {
    width: fit-content;
    height: 40px;
    span {
      font-size: 14px;
      font-weight: 700;
    }
  }
  .el-input__inner {
    height: 48px !important;
    border-radius: 8px;
  }
  .grid.grid-cols-3 {
    .el-radio-button {
      --el-radio-button-checked-border-color: var(--primary);
      --el-radio-button-checked-bg-color: rgb(0, 0, 0, 0);
      --el-radio-button-checked-text-color: var(--text);
      margin-right: 0;
      height: 100%;
      min-height: 32px;
      border-radius: 4px;
      &.is-active {
        & .el-radio-button__inner {
          @apply rounded-lg w-full text-center p-0 h-full min-h-[32px] pl-0 inline-flex items-center justify-center leading-[14px] text-xs font-bold;
          box-shadow: none !important;
          border: var(--secondary) solid 1px;
          white-space: break-spaces;
          color: var(--secondary);
        }
      }
      & .el-radio-button__inner {
        @apply rounded-lg w-full text-center p-0 h-full min-h-[32px] pl-0 inline-flex items-center justify-center leading-[14px] text-xs font-bold;
        box-shadow: none !important;
        border: var(--border) solid 1px;
        white-space: break-spaces;
        color: var(--text);
      }
      & .el-radio-button__inner::before {
        background: var(--secondary) !important;
      }
      .el-radio-button__original-radio:checked + .el-radio-button__inner,
      &:first-child
        .el-radio-button__original-radio:checked
        + .el-radio-button__inner {
        border-color: var(--secondary);
      }
    }
  }
  .mx-auto.px-5.bg-1 {
    margin-right: 0;
    margin-left: 0;
    background: var(--background2);
    padding: 0;
    .demo-tabs {
      & .el-tabs__nav-wrap {
        padding: 0;
        .el-tabs__nav-scroll {
          overflow: auto;
        }
        & .el-tabs__nav {
          width: 100%;
        }
        & .el-tabs__active-bar {
          width: 25%;
          background-color: var(--secondary);
        }
        & .el-tabs__item.is-active {
          color: var(--secondary);
        }
        & .el-tabs__item {
          min-width: 92px;
          text-align: center;
          padding-left: 14px !important;
          padding-right: 14px !important;
        }
      }
    }
    & .flex-auto {
      padding-left: 20px;
      padding-right: 20px;
      height: calc(100vh - 106px);
      padding-bottom: 5rem;
      overflow: auto;
      .el-card.is-always-shadow {
        background: var(--background1);
        border-radius: 8px;
        button.el-button {
          min-width: 78px;
          height: 30px;
        }
      }
    }
  }
  .flex.flex-col.bg-background2 {
    .el-tabs__header {
      .el-tabs__item.is-active {
        color: var(--secondary);
      }
      .el-tabs__active-bar {
        background-color: var(--secondary);
      }
    }
    .el-tabs__content {
      margin-top: 35px;
      padding-top: 0.75rem;
      overflow: auto;
      height: calc(100vh - 87px);
      padding-bottom: 6rem;
      .setting-tab {
        position: unset;
      }
      .el-radio__input.is-checked .el-radio__inner {
        border-color: var(--hint);
        background: var(--hint);
      }
      .el-radio__input.is-checked + .el-radio__label {
        color: var(--hint);
      }
    }
  }
}
[data-device="mobile"] {
  .el-tabs__nav-scroll::-webkit-scrollbar {
    display: none;
  }
}
</style>
<style scoped>
:deep(.el-collapse-item__wrap),
:deep(.el-collapse-item__header) {
  border-bottom: unset;
}
:deep(.el-icon.el-collapse-item__arrow) {
  display: none;
}
:deep(.el-input__suffix) {
  color: var(--secondary);
}
:deep(.footer-menu-item-title:not(.text-\[color\:var\(--selected\)\])) {
  color: var(--text5);
}
[theme-color="global_light_01"] :deep(.footer-menu-item-title:not(.text-\[color\:var\(--selected\)\])) {
  color: var(--text3) !important;
}
</style>